#ifndef GRAPPLE_THREAD_H
#define GRAPPLE_THREAD_H

#include <pthread.h>

typedef struct 
{
  pthread_mutex_t mutex;
  pthread_mutex_t countmutex;
  int lockcount;
  int exlockcount;
} grapple_thread_mutex;

typedef enum
  {
    GRAPPLE_LOCKTYPE_EXCLUSIVE,
    GRAPPLE_LOCKTYPE_SHARED,
  } grapple_mutex_locktype;


#define g2rapple_thread_mutex_lock(a,b) debug_grapple_thread_mutex_lock(a,b,__FILE__,__LINE__)
#define g2rapple_thread_mutex_unlock(a) debug_grapple_thread_mutex_unlock(a,__FILE__,__LINE__)

extern grapple_thread_mutex *grapple_thread_mutex_init(void);
extern int grapple_thread_mutex_destroy(grapple_thread_mutex *);
extern int grapple_thread_mutex_lock(grapple_thread_mutex *,
				     grapple_mutex_locktype);
extern int grapple_thread_mutex_trylock(grapple_thread_mutex *,
					grapple_mutex_locktype);
extern int grapple_thread_mutex_unlock(grapple_thread_mutex *);


extern int debug_grapple_thread_mutex_lock(grapple_thread_mutex *,
					   grapple_mutex_locktype,
					   const char *,int);
extern int debug_grapple_thread_mutex_unlock(grapple_thread_mutex *,
					     const char *,int);

#endif
